## postgres-xc 1.0.2

=== contrib/pgxc_clean/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for contrib/pgxc_clean
#
# Portions Copyright (c) 2010-2013, Postgres-XC Development Group
#
# $PostgreSQL$
#
#-------------------------------------------------------------------------

PGFILEDESC = "pgxc_clean - Abort prepared transaction for a Postgres-XC Coordinator"
PGAPPICON = win32

PROGRAM= pgxc_clean
OBJS= pgxc_clean.o txninfo.o

#Include GTM objects
gtm_builddir = $(top_builddir)/src/gtm
EX_OBJS = $(gtm_builddir)/common/assert.o \
	  $(gtm_builddir)/client/libgtmclient.a

PG_CPPFLAGS  = -DFRONTEND -DDLSUFFIX=\"$(DLSUFFIX)\" -I$(srcdir) -I$(libpq_srcdir)
PG_LIBS = $(libpq_pgport) $(PTHREAD_LIBS)

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/pgxc_clean
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== src/bin/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin (client programs)
#
# Portions Copyright (c) 1996-2011, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/Makefile
#
#-------------------------------------------------------------------------

subdir = src/bin
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = initdb initgtm pg_ctl pg_dump \
	psql scripts pg_config pg_controldata pg_resetxlog pg_basebackup

ifeq ($(PORTNAME), win32)
SUBDIRS += pgevent
else
ALWAYS_SUBDIRS += pgevent
endif

$(recurse)
$(recurse_always)

=== src/pgxc/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC documentation tool makefile
#
# Copyright (c) 2010-2013, Postgres-XC Development Group
#
# doc-xc/Makefile
#
#----------------------------------------------------------------------------

subdir = src/pgxc
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = tools

$(recurse)

=== doc-xc/src/sgml/Makefile ===
#----------------------------------------------------------------------------
#
# PostgreSQL documentation makefile
#
# doc/src/sgml/Makefile
#
#----------------------------------------------------------------------------

# This makefile is for building and installing the documentation.
# When a release tarball is created, the documentation files are
# prepared using the distprep target.  In Git-based trees these files
# don't exist, unless explicitly built, so we skip the installation in
# that case.


# Make "html" the default target, since that is what most people tend
# to want to use.
html:

subdir = doc-xc/src/sgml
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

MAKESGMLDIR = $(top_builddir)/src/pgxc/tools/makesgml
MAKESGML = $(MAKESGMLDIR)/makesgml


all: html man

distprep: html distprep-man


ifndef COLLATEINDEX
COLLATEINDEX = $(DOCBOOKSTYLE)/bin/collateindex.pl
endif

ifndef JADE
JADE = jade
endif
SGMLINCLUDE = -D . -D $(srcdir)

ifndef NSGMLS
NSGMLS = nsgmls
endif

ifndef OSX
OSX = osx
endif

ifndef XSLTPROC
XSLTPROC = xsltproc
endif

VERSION = 1.0.2

override XSLTPROCFLAGS += --stringparam pg.version '$(VERSION)'


GENERATED_SGML = bookindex.sgml version.sgml \
	features-supported.sgml features-unsupported.sgml errcodes-table.sgml

ALLSGMLIN := $(wildcard $(srcdir)/*.sgmlin $(srcdir)/ref/*.sgmlin)

#ALLSGML := $(wildcard $(srcdir)/*.sgml $(srcdir)/ref/*.sgml) $(GENERATED_SGML)
ALLSGML := $(ALLSGMLIN:%sgmlin=%sgml) $(GENERATED_SGML)

ALLSGMLTOREMOVE := $(ALLSGMLIN:%sgmlin=%sgml)


# Sometimes we don't want this one.
ALMOSTALLSGML := $(filter-out %bookindex.sgml,$(ALLSGML))

ifdef DOCBOOKSTYLE
CATALOG = -c $(DOCBOOKSTYLE)/catalog
endif

# Enable some extra warnings
# -wfully-tagged needed to throw a warning on missing tags
# for older tool chains, 2007-08-31
# Note: try "make SPFLAGS=-wxml" to catch a lot of other dubious constructs,
# in particular < and & that haven't been made into entities.  It's far too
# noisy to turn on by default, unfortunately.
override SPFLAGS += -wall -wno-unused-param -wno-empty -wfully-tagged

##
## SGML files
##

sgml-files: $(ALLSGMLIN:%sgmlin=%sgml)

##
## Man pages
##

man distprep-man: man-stamp

man-stamp: stylesheet-man.xsl postgres.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) $(XSLTPROC_MAN_FLAGS) $^
	touch $@


##
## HTML
##

.PHONY: draft

JADE.html.call = $(JADE) $(JADEFLAGS) $(SPFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -t sgml -i output-html

# The draft target creates HTML output in draft mode, without index (for faster build).
draft: postgres.sgml $(ALMOSTALLSGML) stylesheet.dsl
	$(MKDIR_P) html
	$(JADE.html.call) -V draft-mode $<
	cp $(srcdir)/stylesheet.css html/

html: html-stamp

html-stamp: postgres.sgml $(ALLSGML) stylesheet.dsl
	$(MKDIR_P) html
	$(JADE.html.call) -i include-index $<
	cp $(srcdir)/stylesheet.css html/
	touch $@

# single-page HTML
postgres.html: postgres.sgml $(ALLSGML) stylesheet.dsl
	$(JADE.html.call) -V nochunks -V rootchunk -V '(define %root-filename% #f)' -V '(define use-output-dir #f)' -i include-index $<

# single-page text
postgres.txt: postgres.html
	$(LYNX) -force_html -dump -nolist $< > $@

HTML.index: postgres.sgml $(ALMOSTALLSGML) stylesheet.dsl
	@$(MKDIR_P) html
	$(JADE.html.call) -V html-index $<

bookindex.sgml: HTML.index
	LC_ALL=C $(PERL) $(COLLATEINDEX) -f -g -i 'bookindex' -o $@ $<

# Technically, this should depend on Makefile.global, but then
# version.sgml would need to be rebuilt after every configure run,
# even in distribution tarballs.  So this is cheating a bit, but it
# will achieve the goal of updating the version number when it
# changes.
version.sgml: $(top_srcdir)/configure
	{ \
	  echo "<!ENTITY version \"$(VERSION)\">"; \
	  echo "<!ENTITY majorversion \"$(MAJORVERSION)\">"; \
	} > $@

features-supported.sgml: $(top_srcdir)/src/backend/catalog/sql_feature_packages.txt $(top_srcdir)/src/backend/catalog/sql_features.txt
	$(PERL) $(srcdir)/mk_feature_tables.pl YES $^ > $@

features-unsupported.sgml: $(top_srcdir)/src/backend/catalog/sql_feature_packages.txt $(top_srcdir)/src/backend/catalog/sql_features.txt
	$(PERL) $(srcdir)/mk_feature_tables.pl NO $^ > $@

errcodes-table.sgml: $(top_srcdir)/src/backend/utils/errcodes.txt generate-errcodes-table.pl
	$(PERL) $(srcdir)/generate-errcodes-table.pl $< > $@

##
## Print
##


# RTF to allow minor editing for hardcopy
%.rtf: %.sgml $(ALLSGML)
	$(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -t rtf -V rtf-backend -i output-print  -i include-index postgres.sgml

# TeX
# Regular TeX and pdfTeX have slightly differing requirements, so we
# need to distinguish the path we're taking.

JADE.tex.call = $(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d $(srcdir)/stylesheet.dsl -t tex -V tex-backend -i output-print -i include-index

%-A4.tex-ps: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texdvi-output -V '%paper-type%'=A4 -o $@ $<

%-US.tex-ps: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texdvi-output -V '%paper-type%'=USletter -o $@ $<

%-A4.tex-pdf: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texpdf-output -V '%paper-type%'=A4 -o $@ $<

%-US.tex-pdf: %.sgml $(ALLSGML)
	$(JADE.tex.call) -V texpdf-output -V '%paper-type%'=USletter -o $@ $<

%.dvi: %.tex-ps
	@rm -f $*.aux $*.log
# multiple runs are necessary to create proper intra-document links
	jadetex $<
	jadetex $<
	jadetex $<

# PostScript from TeX
postgres.ps:
	$(error Invalid target;  use postgres-A4.ps or postgres-US.ps as targets)

%.ps: %.dvi
	dvips -o $@ $<

postgres.pdf:
	$(error Invalid target;  use postgres-A4.pdf or postgres-US.pdf as targets)

%.pdf: %.tex-pdf
	@rm -f $*.aux $*.log $*.out
# multiple runs are necessary to create proper intra-document links
	pdfjadetex $<
	pdfjadetex $<
	pdfjadetex $<

# Cancel built-in suffix rules, interfering with PS building
.SUFFIXES:
.SUFFIXES: .sgml .sgmlin

INC_LIST = -I PG -I EN
#INC_LIST = -I PGXC -I EN

.sgmlin.sgml:
	$(MAKE) -C $(MAKESGMLDIR)
	$(MAKESGML) -i $< -o $@ $(INC_LIST) $(EXC_LIST)


# This generates an XML version of the flow-object tree.  It's useful
# for debugging DSSSL code, and possibly to interface to some other
# tools that can make use of this.
%.fot: %.sgml $(ALLSGML)
	$(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -t fot -i output-print -i include-index -o $@ $<


##
## Semi-automatic generation of some text files.
##

JADE.text = $(JADE) $(JADEFLAGS) $(SGMLINCLUDE) $(CATALOG) -d stylesheet.dsl -i output-text -t sgml
LYNX = lynx

INSTALL HISTORY regress_README: % : %.html
	$(PERL) -p -e 's/<H(1|2)$$/<H\1 align=center/g' $< | $(LYNX) -force_html -dump -nolist -stdin > $@

INSTALL.html: standalone-install.sgml installation.sgml version.sgml
	$(JADE.text) -V nochunks standalone-install.sgml installation.sgml > $@

HISTORY.html: generate_history.pl $(wildcard $(srcdir)/release*.sgml)
	$(PERL) $< "$(srcdir)" release.sgml >tempfile_HISTORY.sgml
	$(JADE.text) -V nochunks tempfile_HISTORY.sgml > $@
	rm tempfile_HISTORY.sgml

regress_README.html: regress.sgml
	( echo '<!DOCTYPE chapter PUBLIC "-//OASIS//DTD DocBook V4.2//EN" ['; \
	  echo '<!ENTITY % standalone-ignore "IGNORE">'; \
	  echo '<!ENTITY % standalone-include "INCLUDE"> ]>'; \
	  cat $< ) >tempfile_regress_README.sgml
	$(JADE.text) -V nochunks tempfile_regress_README.sgml > $@
	rm tempfile_regress_README.sgml


##
## XSLT processing
##

# For obscure reasons, gmake 3.81 complains about circular dependencies
# if we try to do "make all" in a VPATH build without the explicit
# $(srcdir) on the postgres.sgml dependency in this rule.  gmake bug?
postgres.xml: $(srcdir)/postgres.sgml $(ALMOSTALLSGML)
	$(OSX) -D. -x lower $< >postgres.xmltmp
	$(PERL) -p -e 's/\[(amp|copy|egrave|gt|lt|mdash|nbsp|ouml|pi|quot|uuml) *\]/\&\1;/g;' \
	           -e '$$_ .= qq{<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.2//EN" "http://www.oasis-open.org/docbook/xml/4.2/docbookx.dtd">\n} if $$. == 1;' \
	  <postgres.xmltmp > $@
	rm postgres.xmltmp
# ' hello Emacs

xslthtml: stylesheet.xsl postgres.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) $(XSLTPROC_HTML_FLAGS) $^

htmlhelp: stylesheet-hh.xsl postgres.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) $^

%-A4.fo: stylesheet-fo.xsl %.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) --stringparam paper.type A4 -o $@ $^

%-US.fo: stylesheet-fo.xsl %.xml
	$(XSLTPROC) $(XSLTPROCFLAGS) --stringparam paper.type USletter -o $@ $^


##
## Experimental Texinfo targets
##

DB2X_TEXIXML = db2x_texixml
DB2X_XSLTPROC = db2x_xsltproc
MAKEINFO = makeinfo

%.texixml: %.xml
	$(DB2X_XSLTPROC) -s texi -g output-file=$(basename $@) $< -o $@

%.texi: %.texixml
	$(DB2X_TEXIXML) --encoding=iso-8859-1//TRANSLIT $< --to-stdout > $@

%.info: %.texi
	$(MAKEINFO) --enable-encoding --no-split --no-validate $< -o $@


##
## Check
##

# Quick syntax check without style processing
check maintainer-check: postgres.sgml $(ALMOSTALLSGML) check-tabs
	$(NSGMLS) $(SPFLAGS) $(SGMLINCLUDE) -s $<


##
## Install
##

install: install-html

ifneq ($(PORTNAME), sco)
install: install-man
endif

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(htmldir)'/html $(addprefix '$(DESTDIR)$(mandir)'/man, 1 3 $(sqlmansectnum))

uninstall:
	rm -f '$(DESTDIR)$(htmldir)/html/'* $(addprefix  '$(DESTDIR)$(mandir)'/man, 1/* 3/* $(sqlmansectnum)/*)


## Install html

install-html: html installdirs
	cp -R $(call vpathsearch,html) '$(DESTDIR)$(htmldir)'


## Install man

install-man: man installdirs

sqlmansect ?= 7
sqlmansectnum = $(shell expr X'$(sqlmansect)' : X'\([0-9]\)')

# Before we install the man pages, we massage the section numbers to
# follow the local conventions.
#
ifeq ($(sqlmansectnum),7)
install-man:
	cp -R $(foreach dir,man1 man3 man7,$(call vpathsearch,$(dir))) '$(DESTDIR)$(mandir)'

else # sqlmansectnum != 7
fix_sqlmansectnum = sed -e '/^\.TH/s/"7"/"$(sqlmansect)"/' \
			-e 's/\\fR(7)/\\fR($(sqlmansectnum))/g' \
			-e '1s/^\.so man7/.so man$(sqlmansectnum)/g;1s/^\(\.so.*\)\.7$$/\1.$(sqlmansect)/g'

man: fixed-man-stamp

fixed-man-stamp: man-stamp
	@$(MKDIR_P) $(addprefix fixedman/,man1 man3 man$(sqlmansectnum))
	for file in $(call vpathsearch,man1)/*.1; do $(fix_sqlmansectnum) $$file >fixedman/man1/`basename $$file` || exit; done
	for file in $(call vpathsearch,man3)/*.3; do $(fix_sqlmansectnum) $$file >fixedman/man3/`basename $$file` || exit; done
	for file in $(call vpathsearch,man7)/*.7; do $(fix_sqlmansectnum) $$file >fixedman/man$(sqlmansectnum)/`basename $$file | sed s/\.7$$/.$(sqlmansect)/` || exit; done

install-man:
	cp -R $(foreach dir,man1 man3 man$(sqlmansectnum),fixedman/$(dir)) '$(DESTDIR)$(mandir)'

clean: clean-man clean-sgml

.PHONY: clean-man
clean-man:
	rm -rf fixedman/ fixed-man-stamp

.PHONY: clean-sgml:
clean-sgml:
	rm -rf $(ALLSGML)

endif # sqlmansectnum != 7

# tabs are harmless, but it is best to avoid them in SGML files
check-tabs:
	@( ! grep '	' $(wildcard $(srcdir)/*.sgml $(srcdir)/ref/*.sgml) ) || (echo "Tabs appear in SGML files";  exit 1)

##
## Clean
##

# This allows removing some files from the distribution tarballs while
# keeping the dependencies satisfied.
.SECONDARY: postgres.xml $(GENERATED_SGML) HTML.index
.SECONDARY: INSTALL.html HISTORY.html regress_README.html
.SECONDARY: %-A4.tex-ps %-US.tex-ps %-A4.tex-pdf %-US.tex-pdf

clean:
# text --- these are shipped, but not in this directory
	rm -f INSTALL HISTORY regress_README
	rm -f INSTALL.html HISTORY.html regress_README.html
# single-page output
	rm -f postgres.html postgres.txt
# print
	rm -f *.rtf *.tex-ps *.tex-pdf *.dvi *.aux *.log *.ps *.pdf *.out *.fot
# index
	rm -f HTML.index $(GENERATED_SGML)
# XSLT
	rm -f postgres.xml postgres.xmltmp htmlhelp.hhp toc.hhc index.hhk *.fo
# Texinfo
	rm -f *.texixml *.texi *.info db2texi.refs

distclean: clean

maintainer-clean: distclean
# HTML
	rm -fr html/ html-stamp
# man
	rm -rf man1/ man3/ man7/ man-stamp
# sgml
	rm -f $(ALLSGMLTOREMOVE)

.PHONY: sgmlfiles

INC_LIST = -I XC -I EN
EXC_LIST = -E PG -E JP

sgmlfiles:
	./makesgmlfiles $(INC_LIST) $(EXC_LIST)

=== src/backend/catalog/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for backend/catalog
#
# src/backend/catalog/Makefile
#
#-------------------------------------------------------------------------

subdir = src/backend/catalog
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

OBJS = catalog.o dependency.o heap.o index.o indexing.o namespace.o aclchk.o \
       objectaddress.o pg_aggregate.o pg_collation.o pg_constraint.o pg_conversion.o \
       pg_depend.o pg_enum.o pg_inherits.o pg_largeobject.o pg_namespace.o \
       pg_operator.o pg_proc.o pg_db_role_setting.o pg_shdepend.o pg_type.o \
       pgxc_class.o storage.o toasting.o

BKIFILES = postgres.bki postgres.description postgres.shdescription

include $(top_srcdir)/src/backend/common.mk

all: $(BKIFILES) schemapg.h

# Note: there are some undocumented dependencies on the ordering in which
# the catalog header files are assembled into postgres.bki.  In particular,
# indexing.h had better be last, and toasting.h just before it.

POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
	pg_proc.h pg_type.h pg_attribute.h pg_class.h \
	pg_attrdef.h pg_constraint.h pg_inherits.h pg_index.h pg_operator.h \
	pg_opfamily.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
	pg_language.h pg_largeobject_metadata.h pg_largeobject.h pg_aggregate.h \
	pg_statistic.h pg_rewrite.h pg_trigger.h pg_description.h \
	pg_cast.h pg_enum.h pg_namespace.h pg_conversion.h pg_depend.h \
	pg_database.h pg_db_role_setting.h pg_tablespace.h pg_pltemplate.h \
	pg_authid.h pg_auth_members.h pg_shdepend.h pg_shdescription.h \
	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
	pg_ts_parser.h pg_ts_template.h pg_extension.h \
	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
	pgxc_class.h pgxc_node.h pgxc_group.h \
	pg_foreign_table.h \
	pg_default_acl.h pg_seclabel.h pg_collation.h \
	toasting.h indexing.h \
    )

# location of Catalog.pm
catalogdir = $(top_srcdir)/src/backend/catalog

# locations of headers that genbki.pl needs to read
pg_includes = -I$(top_srcdir)/src/include/catalog -I$(top_builddir)/src/include/catalog

# see explanation in ../parser/Makefile
postgres.description: postgres.bki ;

postgres.shdescription: postgres.bki ;

schemapg.h: postgres.bki ;

postgres.bki: genbki.pl Catalog.pm $(POSTGRES_BKI_SRCS)
	$(PERL) -I $(catalogdir) $< $(pg_includes) --set-version=$(MAJORVERSION) $(POSTGRES_BKI_SRCS)

.PHONY: install-data
install-data: $(BKIFILES) installdirs
	$(INSTALL_DATA) $(call vpathsearch,postgres.bki) '$(DESTDIR)$(datadir)/postgres.bki'
	$(INSTALL_DATA) $(call vpathsearch,postgres.description) '$(DESTDIR)$(datadir)/postgres.description'
	$(INSTALL_DATA) $(call vpathsearch,postgres.shdescription) '$(DESTDIR)$(datadir)/postgres.shdescription'
	$(INSTALL_DATA) $(srcdir)/system_views.sql '$(DESTDIR)$(datadir)/system_views.sql'
	$(INSTALL_DATA) $(srcdir)/information_schema.sql '$(DESTDIR)$(datadir)/information_schema.sql'
	$(INSTALL_DATA) $(srcdir)/sql_features.txt '$(DESTDIR)$(datadir)/sql_features.txt'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(datadir)'

.PHONY: uninstall-data
uninstall-data:
	rm -f $(addprefix '$(DESTDIR)$(datadir)'/, $(BKIFILES) system_views.sql information_schema.sql sql_features.txt)

# postgres.bki, postgres.description, postgres.shdescription, and schemapg.h
# are in the distribution tarball, so they are not cleaned here.
clean:

maintainer-clean: clean
	rm -f $(BKIFILES)

=== src/bin/psql/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin/psql
#
# Portions Copyright (c) 1996-2011, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/psql/Makefile
#
#-------------------------------------------------------------------------

PGFILEDESC = "psql - the PostgreSQL interactive terminal"
PGAPPICON=win32

subdir = src/bin/psql
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

REFDOCDIR= $(top_srcdir)/doc-xc/src/sgml/ref

MAKESGMLDIR = $(top_builddir)/src/pgxc/tools/makesgml
SGMLDIR= $(top_builddir)/doc-xc/src/sgml

override CPPFLAGS := -I. -I$(srcdir) -I$(libpq_srcdir) -I$(top_srcdir)/src/bin/pg_dump $(CPPFLAGS)

OBJS=	command.o common.o help.o input.o stringutils.o mainloop.o copy.o \
	startup.o prompt.o variables.o large_obj.o print.o describe.o \
	tab-complete.o mbprint.o dumputils.o keywords.o kwlookup.o \
	sql_help.o \
	$(WIN32RES)

FLEXFLAGS = -Cfe


all: psql

psql: $(OBJS) | submake-libpq submake-libpgport
	$(CC) $(CFLAGS) $(OBJS) $(libpq_pgport) $(LDFLAGS) $(LDFLAGS_EX) $(LIBS) -o $@$(X)

help.o: sql_help.h

dumputils.c keywords.c: % : $(top_srcdir)/src/bin/pg_dump/%
	rm -f $@ && $(LN_S) $< .

kwlookup.c: % : $(top_srcdir)/src/backend/parser/%
	rm -f $@ && $(LN_S) $< .

sql_help.c: sql_help.h ;
sql_help.h: create_help.pl $(wildcard $(REFDOCDIR)/*.sgml)
	$(MAKE) -C $(MAKESGMLDIR)
	$(MAKE) -C $(SGMLDIR) sgml-files
	$(PERL) $< $(REFDOCDIR) $*

# psqlscan is compiled as part of mainloop
mainloop.o: psqlscan.c

psqlscan.c: psqlscan.l
ifdef FLEX
	$(FLEX) $(FLEXFLAGS) -o'$@' $<
else
	@$(missing) flex $< $@
endif

distprep: sql_help.h psqlscan.c

install: all installdirs
	$(INSTALL_PROGRAM) psql$(X) '$(DESTDIR)$(bindir)/psql$(X)'
	$(INSTALL_DATA) $(srcdir)/psqlrc.sample '$(DESTDIR)$(datadir)/psqlrc.sample'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)'

uninstall:
	rm -f '$(DESTDIR)$(bindir)/psql$(X)' '$(DESTDIR)$(datadir)/psqlrc.sample'

# psqlscan.c is in the distribution tarball, so is not cleaned here
clean distclean:
	rm -f psql$(X) $(OBJS) dumputils.c keywords.c kwlookup.c

maintainer-clean: distclean
	rm -f sql_help.h sql_help.c psqlscan.c

=== src/gtm/client/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM client makefile
#
# Copyright (c) 2010-2013, Postgres-XC Development Group
#
# src/gtm/client/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/client

NAME=gtmclient
SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

OBJS=fe-misc.o fe-connect.o pqexpbuffer.o ip.o strlcpy.o gtm_client.o fe-protocol.o
LDFLAGS=-L$(top_build_dir)/common -L$(top_build_dir)/libpq

LIBS=-lpthread

all:all-lib

include $(top_srcdir)/src/Makefile.shlib

clean:
	rm -f $(OBJS)
	rm -f libgtmclient.a libgtmclient.so libgtmclient.so.1 libgtmclient.so.1.0

distclean: clean

maintainer-clean: distclean

=== src/gtm/common/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM common makefile
#
# Copyright (c) 2010-2013, Postgres-XC Development Group
#
# src/gtm/common/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
subdir=src/gtm/common

include $(top_builddir)/src/Makefile.global

override CPPFLAGS := -I. -I$(srcdir) $(CPPFLAGS)

NAME=gtm

SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

LDFLAGS=-L$(top_builddir)/common -L$(top_builddir)/libpq
LIBS=-lpthread

OBJS = gtm_opt_handler.o aset.o mcxt.o gtm_utils.o elog.o assert.o stringinfo.o gtm_lock.o \
       gtm_list.o gtm_serialize.o gtm_serialize_debug.o

all:all-lib

gtm_opt_handler.o: gtm_opt_scanner.c

gtm_opt_scanner.c: gtm_opt_scanner.l
ifdef FLEX
	$(FLEX) $(FLEXFLAGS) -o'$@' $<
else
	@$(missing) flex $< $@
endif

# Shared library stuff
include $(top_srcdir)/src/Makefile.shlib

# Note that gtm_opt_scanner.c is not deleted by make clean as we want it in distribution tarballs
clean:
	rm -f $(OBJS)
	rm -f libgtm.so libgtm.so.1 libgtm.so.1.0

distclean: clean

maintainer-clean: distclean

=== src/gtm/main/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM main Makefile
#
# Copyright (c) 2010-2013, Postgres-XC Development Group
#
# src/gtm/main/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/main

ifneq ($(PORTNAME), win32)
override CFLAGS += $(PTHREAD_CFLAGS)
endif

OBJS=main.o gtm_thread.o gtm_txn.o gtm_seq.o gtm_snap.o gtm_time.o gtm_standby.o gtm_opt.o

OTHERS= ../libpq/libpqcomm.a ../path/libgtmpath.a ../recovery/libgtmrecovery.a ../client/libgtmclient.a ../common/libgtm.a ../../port/libpgport.a 

LDFLAGS=-L$(top_builddir)/common -L$(top_builddir)/libpq

LIBS=-lpthread

gtm:$(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LIBS) $^ $(OTHERS) -o gtm

all:gtm

clean:
	rm -f $(OBJS)
	rm -f gtm

distclean: clean

maintainer-clean: distclean

=== src/gtm/recovery/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM recovery makefile
#
# Copyright (c) 2010-2013, Postgres-XC Development Group
#
# src/gtm/recovery/Makefile
#
#-----------------------------------------------------------------------------
top_builddir=../../..
include $(top_builddir)/src/Makefile.global
subdir=src/gtm/recovery

NAME=gtmrecovery
SO_MAJOR_VERSION= 1
SO_MINOR_VERSION= 0

OBJS=register_common.o register_gtm.o replication.o standby_utils.o

OTHERS=../client/libgtmclient.a

all:all-lib

include $(top_srcdir)/src/Makefile.shlib

clean:
	rm -f $(OBJS)
	rm -f libgtmrecovery.a libgtmrecovery.so libgtmrecovery.so.1 libgtmrecovery.so.1.0 

distclean: clean

maintainer-clean: distclean

=== src/gtm/test2/Makefile ===
#----------------------------------------------------------------------------
#
# Postgres-XC GTM test2 makefile
#
# Copyright (c) 2010-2013, Postgres-XC Development Group
#
# src/gtm/test2/Makefile
#
#-----------------------------------------------------------------------------
top_build_dir=../..
include $(top_build_dir)/gtm/Makefile.global

override CPPFLAGS := -I$(top_build_dir)/gtm/client $(CPPFLAGS)

SRCS=test_serialize.c test_connect.c test_node.c test_node5.c test_txn.c test_txn4.c test_txn5.c test_repli.c test_repli2.c test_seq.c test_seq4.c test_seq5.c test_scenario.c test_startup.c test_standby.c test_common.c

PROGS=test_serialize test_connect test_txn test_txn4 test_txn5 test_repli test_repli2 test_seq test_seq4 test_seq5 test_scenario test_startup test_node test_node5 test_standby

OBJS=$(SRCS:.c=.o)
LIBS=$(top_build_dir)/gtm/client/libgtmclient.a \
  $(top_build_dir)/gtm/common/libgtm.a \
  $(top_build_dir)/gtm/libpq/libpqcomm.a

LOADLIBES=-lpthread
CFLAGS=-g -O0

all: $(PROGS)

test_serialize: test_serialize.o test_common.o $(LIBS)

test_connect: test_connect.o test_common.o $(LIBS)
test_startup: test_startup.o test_common.o $(LIBS)

test_node: test_node.o test_common.o $(LIBS)
test_node5: test_node5.o test_common.o $(LIBS)

test_txn: test_txn.o test_common.o $(LIBS)

test_txn4: test_txn4.o test_common.o $(LIBS)
test_txn5: test_txn5.o test_common.o $(LIBS)

test_repli: test_repli.o test_common.o $(LIBS)

test_standby: test_standby.o test_common.o $(LIBS)

test_repli2: test_repli2.o test_common.o $(LIBS)

test_seq: test_seq.o test_common.o $(LIBS)
test_seq4: test_seq4.o test_common.o $(LIBS)
test_seq5: test_seq5.o test_common.o $(LIBS)

test_scenario: test_scenario.o test_common.o $(LIBS)

clean:
	rm -f $(OBJS) *~
	rm -f $(PROGS)

distclean: clean

maintainer-clean: distclean

=== src/backend/pgxc/barrier/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile--
#    Makefile for barrier
#
#  Portions Copyright (c) 2010-2013, Postgres-XC Development Group
#
# IDENTIFICATION
#    $PostgreSQL$
#
#-------------------------------------------------------------------------

subdir = src/backend/pgxc/barrier
top_builddir = ../../../..
include $(top_builddir)/src/Makefile.global

OBJS = barrier.o

include $(top_srcdir)/src/backend/common.mk

=== debian/changelog ===
postgres-xc (1.0.2-1ubuntu1) raring; urgency=low

  * Made d/rules multiarch-Tcl-aware, fixing FTBFS.
  * Fixed implicit declaration warnings that would have caused FTBFS on
    amd64 buildds.

 -- Daniel T Chen <crimsun@ubuntu.com>  Thu, 18 Apr 2013 17:19:22 -0400

postgres-xc (1.0.2-1) unstable; urgency=low

  * Updated watch file.
    Thanks to Bart Martens <bartm@debian.org>
  * Imported Upstream version 1.0.2
  * Bumped Standards-Version to 3.9.4, no changes needed.

 -- Michael Meskes <meskes@debian.org>  Thu, 07 Feb 2013 13:10:05 +0100

postgres-xc (1.0.1-1) unstable; urgency=low

  [ Vladimir Stavrinov ]
  * New upstream release.
  * Syntax fix in doc-xc/src/sgml/queries.sgmlin
  * If no servers are running, report them all.
  * Init script: replace *&&* with *if then* construct to satisfy lintian false
    error init.d-script-sourcing-without-test.

  [ Michael Meskes ]
  * Added patch to work around stdout not being redirected when starting gtm.

 -- Michael Meskes <meskes@debian.org>  Thu, 10 Jan 2013 13:10:48 +0100

postgres-xc (1.0.0-3) unstable; urgency=low

  * Cannot install server-dev packages for postgres-xc and postgresql at the
    same time. (Closes: #680445)
  * On purge remove all files and directories. (Closes: #680286)

 -- Michael Meskes <meskes@debian.org>  Mon, 09 Jul 2012 11:08:38 +0200

=== debian/control ===
Source: postgres-xc
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Vladimir Stavrinov <vstavrinov@gmail.com>
Uploaders: Michael Meskes <meskes@debian.org>
Build-Depends: debhelper (>= 8.0.0),
 dpkg-dev (>= 1.16.1~) | hardening-wrapper,
 perl (>= 5.8),
 libperl-dev,
 libpq-dev,
 tcl8.5-dev,
 libedit-dev,
 libssl-dev, 
 zlib1g-dev | libz-dev,
 libpam0g-dev | libpam-dev,
 libxml2-dev, libkrb5-dev,
 libldap2-dev,
 libxslt1-dev,
 libossp-uuid-dev,
 python-dev,
 bison,
 flex,
 openjade,
 docbook-dsssl,
 docbook-xsl,
 opensp,
 xsltproc,
 gettext
Standards-Version: 3.9.4
Homepage: http://postgres-xc.sourceforge.net/
Vcs-Git: git://git.debian.org/git/pkg-postgresql/postgres-xc.git
Vcs-Browser: http://git.debian.org/?p=pkg-postgresql/postgres-xc.git

Package: postgres-xc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgres-xc-client,
 adduser, ssl-cert (>= 1.0.11), logrotate
Conflicts: postgresql-common
Description: write-scalable, synchronous multi-master, transparent PostgreSQL cluster
 Write-scalable means Postgres-XC can be configured with as many
 database servers as you want and handle many more writes (updating SQL
 statements) compared to what a single database server can not do.
 .
 Multi-master means you can have more than one database server that
 clients connect to which provide a single, consistent cluster-wide view
 of the database.
 .
 Synchronous means any database update from any database server is
 immediately visible to any other transactions running on different
 masters.
 .
 Transparent means you (and your applications) do not have to worry
 about how your data is stored in more than one database servers
 internally.
 .
 You can configure Postgres-XC to run on multiple servers. Your data is
 stored in a distributed way, that is, partitioned or replicated, as
 chosen by you for each table. When you issue queries, Postgres-XC
 determines where the target data is stored and issues corresponding
 queries to servers containing the target data.

Package: postgres-xc-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, postgres-xc (= ${binary:Version})
Description: debug symbols for postgres-xc
 Write-scalable means Postgres-XC can be configured with as many
 database servers as you want and handle many more writes (updating SQL
 statements) compared to what a single database server can not do.
 .
 Multi-master means you can have more than one database server that
 clients connect to which provide a single, consistent cluster-wide view
 of the database.
 .
 Synchronous means any database update from any database server is
 immediately visible to any other transactions running on different
 masters.
 .
 Transparent means you (and your applications) do not have to worry
 about how your data is stored in more than one database servers
 internally.
 .
 You can configure Postgres-XC to run on multiple servers. Your data is
 stored in a distributed way, that is, partitioned or replicated, as
 chosen by you for each table. When you issue queries, Postgres-XC
 determines where the target data is stored and issues corresponding
 queries to servers containing the target data.
 .
 This package provides detached debugging symbols for Postgres-XC.

Package: postgres-xc-doc
Section: doc
Priority: extra
Architecture: all
Depends: ${misc:Depends}
Description: documentation for the Postgres-XC cluster
 This package contains all README files, user manual, and examples for
 Postgres-XC. The manual is in HTML format.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-client
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Suggests: postgres-xc, postgresql-xc-doc
Conflicts: postgresql-client-common
Description: front-end programs for Postgres-XC
 This package contains client and administrative programs for
 Postgres-XC: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for Postgres-XC. If you install
 Postgres-XC on a standalone machine, you need the server package
 postgres-xc, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .  
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-server-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev (>= 9.1~)
Conflicts: postgresql-common
Description: development files for Postgres-XC server-side programming
 Header files for compiling SSI code to link into Postgres-XC's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on 
 modules of Postgres-XC, which would otherwise have to be built in the
 Postgres-XC source-code tree.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-plperl
Architecture: any
Depends: ${misc:Depends}, 
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version}),
 perl
Description: PL/Perl procedural language for Postgres-XC
 PL/Perl enables an SQL developer to write procedural language functions
 for Postgres-XC in Perl.  You need this package if you have any
 Postgres-XC functions that use the languages plperl or plperlu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-plpython
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version})
Description: PL/Python procedural language for Postgres-XC
 PL/Python enables an SQL developer to write procedural language functions
 for Postgres-XC in Python.  You need this package if you have any
 Postgres-XC functions that use the languages plpython or plpythonu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-pltcl
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgres-xc (= ${binary:Version})
Description: PL/Tcl procedural language for Postgres-XC
 PL/Tcl enables an SQL developer to write procedural language functions
 for Postgres-XC in Tcl.  You need this package if you have any
 Postgres-XC functions that use the languages pltcl or pltclu.
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: postgres-xc-contrib
Architecture: any
Depends: postgres-xc (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: libdbd-pg-perl
Conflicts: postgresql-client-common
Description: additional facilities for Postgres-XC
 The Postgres-XC contrib package provides several additional features
 for the Postgres-XC database.  contrib often serves as a testbed for
 features before they are adopted into PostgreSQL proper:
 .
  adminpack      - File and log manipulation routines, used by pgAdmin
  btree_gist     - B-Tree indexing using GiST (Generalised Search Tree)
  chkpass        - An auto-encrypted password datatype
  cube           - Multidimensional-cube datatype (GiST indexing example)
  dblink         - Functions to return results from a remote database
  earthdistance  - Operator for computing the distance (in miles) between
                   two points on the earth's surface
  fuzzystrmatch  - Levenshtein, metaphone, and soundex fuzzy string matching
  hstore         - Store (key, value) pairs
  intagg         - Integer aggregator/enumerator
  _int           - Index support for arrays of int4, using GiST (benchmark
                   needs the libdbd-pg-perl package)
  isn            - type extensions for ISBN, ISSN, ISMN, EAN13 product numbers
  lo             - Large Object maintenance
  ltree          - Tree-like data structures
  oid2name       - Maps OIDs to table names
  pageinspect    - Inspection of database pages
  passwordcheck  - Simple password strength checker
  pg_buffercache - Real time queries on the shared buffer cache
  pg_freespacemap- Displays the contents of the free space map (FSM)
  pg_trgm        - Determine the similarity of text based on trigram matching
  pg_standby     - Create a warm stand-by server
  pgbench        - TPC-B like benchmark
  pgcrypto       - Cryptographic functions
  pgrowlocks     - A function to return row locking information
  pgstattuple    - Returns the percentage of dead tuples in a table; this
                   indicates whether a vacuum is required.
  seg            - Confidence-interval datatype (GiST indexing example)
  spi            - PostgreSQL Server Programming Interface; 4 examples of
                   its use:
                   autoinc    - A function for implementing AUTOINCREMENT/
                                IDENTITY
                   insert_username - function for inserting user names
                   moddatetime - Update modification timestamps
                   refint     - Functions for implementing referential
                                integrity (foreign keys).  Note that this is
                                now superseded by built-in referential
                                integrity.
                   timetravel - Re-implements in user code the time travel
                                feature that was removed in 6.3.
  tablefunc      - examples of functions returning tables
  uuid-ossp      - UUID generation functions
  vacuumlo       - Remove orphaned large objects
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.

Package: ecpg-xc
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev,
 libecpg-dev (>= 9.1~),
 libecpg6 (>= 9.1~),
 libecpg-compat3 (>= 9.1~),
 libpgtypes3 (>= 9.1~)
Description: Postgres-XC version of ECPG (Embedded PostgreSQL for C)
 This package contains the precompiler ECPG (Embedded
 PostgreSQL for C) for parsing Postgres-XC syntax. 
 .
 Postgres-XC is a write-scalable, synchronous multi-master, transparent
 PostgreSQL cluster.
 . 
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TCL_VER := 8.5

# support both hardening-wrapper (for backports) and dpkg-buildflags
export DEB_BUILD_HARDENING = 1
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
LDFLAGS+= -Wl,--as-needed -Wl,-z,now
CFLAGS+= -fPIC

# When protecting the postmaster with oom_adj=-17, allow the OOM killer to slay
# the backends (http://archives.postgresql.org/pgsql-hackers/2010-01/msg00170.php)
ifeq ($(shell uname -s),Linux)
CFLAGS+= -DLINUX_OOM_ADJ=0
endif

ifneq ($(findstring $(DEB_BUILD_ARCH), sparc alpha),)
# sparc and alpha's gcc currently miscompiles; see
# http://lists.debian.org/debian-alpha/2007/11/msg00025.html
    CFLAGS+=-O1
endif

# build should fail on test suite failures on all arches
TESTSUITE_FAIL_CMD=exit 1

override_dh_auto_clean:
	[ ! -f GNUmakefile ] || make distclean
	-rm -fr build
	-find doc-xc/src/sgml -name "*.sgml" -exec rm -f {} \;
	(cd src/test/regress/sql; \
	  rm -f misc.sql \
	  rm -f create_function_1.sql \
	  rm -f create_function_2.sql \
	  rm -f largeobject.sql \
	  rm -f copy.sql \
	  rm -f constraints.sql \
	  rm -f security_label.sql \
	  rm -f tablespace.sql \
	  rm -f xc_copy.sql)

override_dh_auto_configure:
	mkdir -p build
	cd build && ../configure --prefix=/usr \
		--libdir=/usr/lib/postgres-xc \
		--docdir=/usr/share/doc/postgres-xc-doc \
		--datarootdir=/usr/share \
		--datadir=/usr/share/postgres-xc \
		--includedir=/usr/include/postgres-xc \
		--sysconfdir=/etc \
		--localstatedir=/var \
		--enable-nls \
		--enable-integer-datetimes \
		--enable-thread-safety \
		--enable-debug \
		--disable-maintainer-mode \
		--disable-dependency-tracking \
		--disable-rpath \
		--with-ossp-uuid \
		--with-gnu-ld \
		--with-pgport=5432 \
		--with-system-tzdata=/usr/share/zoneinfo \
		--with-tcl \
		--with-perl \
		--with-python \
		--with-pam \
		--with-krb5 \
		--with-gssapi \
		--with-openssl \
		--with-libxml \
		--with-libxslt \
		--with-ldap \
		--with-tclconfig=/usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(TCL_VER) \
		--with-tkconfig=/usr/lib/$(DEB_HOST_MULTIARCH)/tk$(TCL_VER) \
		--with-includes=/usr/include/tcl$(TCL_VER) 

override_dh_auto_build:
	cd build && $(MAKE)

override_dh_auto_install:
	make -C build install-world DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install

	# these get installed into the individual -/l* packages; -f because it
	# does not exist for an -A build
	rm -f debian/postgres-xc-contrib/usr/share/postgres-xc/extension/pl*

override_dh_strip:
	dh_strip --dbg-package=postgres-xc-dbg

override_dh_auto_test:
ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	# patch away the "don't execute as root" check for the test
	# suite; doing it here will ensure that the actual debs have
	# the check.
	set -e; \
	patch --no-backup-if-mismatch -p1 < debian/disable-root-check.patch; \
	patch --no-backup-if-mismatch -p1 < debian/pg_regress-in-tmp.patch; \
	#make -C build/src/test/regress bigcheck || fail=1; \
	patch --no-backup-if-mismatch -Rp1 < debian/pg_regress-in-tmp.patch; \
	patch --no-backup-if-mismatch -Rp1 < debian/disable-root-check.patch; \
	if [ -n "$$fail" ]; then \
	    for l in regression.diffs log/initdb.log log/postmaster.log; do \
	    	if [ -e build/src/test/regress/$$l ]; then \
		    echo "********* $$l *******"; \
		    cat build/src/test/regress/$$l; \
		fi; \
	    done; \
	    $(TESTSUITE_FAIL_CMD); \
	fi
endif

%:
	dh $@
